> ## Documentation Index
> Fetch the complete documentation index at: https://agentstack.beeai.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# Patch Provider



## OpenAPI

````yaml /development/api-reference/openapi.json patch /api/v1/providers/{id}
openapi: 3.1.0
info:
  title: Agentstack server
  version: 0.6.3
servers: []
security: []
paths:
  /api/v1/providers/{id}:
    patch:
      tags:
        - providers
      summary: Patch Provider
      operationId: patch_provider_api_v1_providers__id__patch
      parameters:
        - name: id
          in: path
          required: true
          schema:
            type: string
            format: uuid
            title: Id
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PatchProviderRequest'
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProviderWithState'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - HTTPBasic: []
        - HTTPBearer: []
components:
  schemas:
    PatchProviderRequest:
      properties:
        location:
          anyOf:
            - $ref: '#/components/schemas/DockerImageProviderLocation'
            - $ref: '#/components/schemas/NetworkProviderLocation'
            - type: 'null'
          title: Location
        agent_card:
          anyOf:
            - $ref: '#/components/schemas/AgentCard-Input'
            - type: 'null'
        variables:
          anyOf:
            - additionalProperties:
                type: string
              type: object
            - type: 'null'
          title: Variables
        origin:
          anyOf:
            - type: string
            - type: 'null'
          title: Origin
          description: >-
            A unique origin of the provider: most often a docker or github
            repository url (without tag). This is used to determine multiple
            versions of the same agent. None means that origin will be
            recomputed from location. To preserve original value, set it
            explicitly.
        auto_stop_timeout_sec:
          anyOf:
            - type: integer
              maximum: 1800
              exclusiveMinimum: 0
            - type: 'null'
          title: Auto Stop Timeout Sec
          description: >-
            Timeout after which the agent provider will be automatically
            downscaled if unused.Contact administrator if you need to increase
            this value.
      type: object
      title: PatchProviderRequest
    ProviderWithState:
      properties:
        source:
          anyOf:
            - $ref: '#/components/schemas/DockerImageProviderLocation'
            - $ref: '#/components/schemas/NetworkProviderLocation'
          title: Source
        id:
          type: string
          format: uuid
          title: Id
        auto_stop_timeout:
          type: string
          format: duration
          title: Auto Stop Timeout
          default: PT20M
        origin:
          type: string
          title: Origin
        version_info:
          $ref: '#/components/schemas/VersionInfo'
        registry:
          anyOf:
            - $ref: '#/components/schemas/GithubRegistryLocation'
            - $ref: '#/components/schemas/NetworkRegistryLocation'
            - $ref: '#/components/schemas/FileSystemRegistryLocation'
            - type: 'null'
          title: Registry
        created_at:
          type: string
          format: date-time
          title: Created At
        updated_at:
          type: string
          format: date-time
          title: Updated At
        created_by:
          type: string
          format: uuid
          title: Created By
        last_active_at:
          type: string
          format: date-time
          title: Last Active At
        agent_card:
          $ref: '#/components/schemas/AgentCard-Output'
        state:
          anyOf:
            - $ref: '#/components/schemas/ProviderDeploymentState'
            - $ref: '#/components/schemas/UnmanagedState'
          title: State
        last_error:
          anyOf:
            - $ref: '#/components/schemas/ProviderErrorMessage'
            - type: 'null'
        missing_configuration:
          items:
            $ref: '#/components/schemas/EnvVar'
          type: array
          title: Missing Configuration
        type:
          $ref: '#/components/schemas/ProviderType'
          readOnly: true
        managed:
          type: boolean
          title: Managed
          readOnly: true
        env:
          items:
            $ref: '#/components/schemas/EnvVar'
          type: array
          title: Env
          readOnly: true
      additionalProperties: true
      type: object
      required:
        - source
        - origin
        - created_by
        - agent_card
        - state
        - type
        - managed
        - env
      title: ProviderWithState
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    DockerImageProviderLocation:
      $ref: '#/components/schemas/DockerImageID'
      title: DockerImageProviderLocation
    NetworkProviderLocation:
      type: string
      maxLength: 2083
      minLength: 1
      format: uri
      title: NetworkProviderLocation
    AgentCard-Input:
      properties:
        additionalInterfaces:
          anyOf:
            - items:
                $ref: '#/components/schemas/AgentInterface'
              type: array
            - type: 'null'
          title: Additionalinterfaces
        capabilities:
          $ref: '#/components/schemas/AgentCapabilities'
        defaultInputModes:
          items:
            type: string
          type: array
          title: Defaultinputmodes
        defaultOutputModes:
          items:
            type: string
          type: array
          title: Defaultoutputmodes
        description:
          type: string
          title: Description
          examples:
            - Agent that helps users with recipes and cooking.
        documentationUrl:
          anyOf:
            - type: string
            - type: 'null'
          title: Documentationurl
        iconUrl:
          anyOf:
            - type: string
            - type: 'null'
          title: Iconurl
        name:
          type: string
          title: Name
          examples:
            - Recipe Agent
        preferredTransport:
          anyOf:
            - type: string
            - type: 'null'
          title: Preferredtransport
          default: JSONRPC
          examples:
            - JSONRPC
            - GRPC
            - HTTP+JSON
        protocolVersion:
          anyOf:
            - type: string
            - type: 'null'
          title: Protocolversion
          default: 0.3.0
        provider:
          anyOf:
            - $ref: '#/components/schemas/AgentProvider'
            - type: 'null'
        security:
          anyOf:
            - items:
                additionalProperties:
                  items:
                    type: string
                  type: array
                type: object
              type: array
            - type: 'null'
          title: Security
          examples:
            - - oauth:
                  - read
              - api-key: []
                mtls: []
        securitySchemes:
          anyOf:
            - additionalProperties:
                $ref: '#/components/schemas/SecurityScheme-Input'
              type: object
            - type: 'null'
          title: Securityschemes
        signatures:
          anyOf:
            - items:
                $ref: '#/components/schemas/AgentCardSignature'
              type: array
            - type: 'null'
          title: Signatures
        skills:
          items:
            $ref: '#/components/schemas/AgentSkill'
          type: array
          title: Skills
        supportsAuthenticatedExtendedCard:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Supportsauthenticatedextendedcard
        url:
          type: string
          title: Url
          examples:
            - https://api.example.com/a2a/v1
        version:
          type: string
          title: Version
          examples:
            - 1.0.0
      type: object
      required:
        - capabilities
        - defaultInputModes
        - defaultOutputModes
        - description
        - name
        - skills
        - url
        - version
      title: AgentCard
      description: >-
        The AgentCard is a self-describing manifest for an agent. It provides
        essential

        metadata including the agent's identity, capabilities, skills, supported

        communication methods, and security requirements.
    VersionInfo:
      properties:
        docker:
          anyOf:
            - $ref: '#/components/schemas/ResolvedDockerImageID'
            - type: 'null'
        github:
          anyOf:
            - $ref: '#/components/schemas/ResolvedGithubUrl'
            - type: 'null'
      type: object
      title: VersionInfo
    GithubRegistryLocation:
      $ref: '#/components/schemas/GithubUrl'
      title: GithubRegistryLocation
    NetworkRegistryLocation:
      type: string
      maxLength: 2083
      minLength: 1
      format: uri
      title: NetworkRegistryLocation
    FileSystemRegistryLocation:
      type: string
      minLength: 1
      format: uri
      title: FileSystemRegistryLocation
    AgentCard-Output:
      properties:
        additionalInterfaces:
          anyOf:
            - items:
                $ref: '#/components/schemas/AgentInterface'
              type: array
            - type: 'null'
          title: Additionalinterfaces
        capabilities:
          $ref: '#/components/schemas/AgentCapabilities'
        defaultInputModes:
          items:
            type: string
          type: array
          title: Defaultinputmodes
        defaultOutputModes:
          items:
            type: string
          type: array
          title: Defaultoutputmodes
        description:
          type: string
          title: Description
          examples:
            - Agent that helps users with recipes and cooking.
        documentationUrl:
          anyOf:
            - type: string
            - type: 'null'
          title: Documentationurl
        iconUrl:
          anyOf:
            - type: string
            - type: 'null'
          title: Iconurl
        name:
          type: string
          title: Name
          examples:
            - Recipe Agent
        preferredTransport:
          anyOf:
            - type: string
            - type: 'null'
          title: Preferredtransport
          default: JSONRPC
          examples:
            - JSONRPC
            - GRPC
            - HTTP+JSON
        protocolVersion:
          anyOf:
            - type: string
            - type: 'null'
          title: Protocolversion
          default: 0.3.0
        provider:
          anyOf:
            - $ref: '#/components/schemas/AgentProvider'
            - type: 'null'
        security:
          anyOf:
            - items:
                additionalProperties:
                  items:
                    type: string
                  type: array
                type: object
              type: array
            - type: 'null'
          title: Security
          examples:
            - - oauth:
                  - read
              - api-key: []
                mtls: []
        securitySchemes:
          anyOf:
            - additionalProperties:
                $ref: '#/components/schemas/SecurityScheme-Output'
              type: object
            - type: 'null'
          title: Securityschemes
        signatures:
          anyOf:
            - items:
                $ref: '#/components/schemas/AgentCardSignature'
              type: array
            - type: 'null'
          title: Signatures
        skills:
          items:
            $ref: '#/components/schemas/AgentSkill'
          type: array
          title: Skills
        supportsAuthenticatedExtendedCard:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Supportsauthenticatedextendedcard
        url:
          type: string
          title: Url
          examples:
            - https://api.example.com/a2a/v1
        version:
          type: string
          title: Version
          examples:
            - 1.0.0
      type: object
      required:
        - capabilities
        - defaultInputModes
        - defaultOutputModes
        - description
        - name
        - skills
        - url
        - version
      title: AgentCard
      description: >-
        The AgentCard is a self-describing manifest for an agent. It provides
        essential

        metadata including the agent's identity, capabilities, skills, supported

        communication methods, and security requirements.
    ProviderDeploymentState:
      type: string
      enum:
        - missing
        - starting
        - ready
        - running
        - error
      title: ProviderDeploymentState
    UnmanagedState:
      type: string
      enum:
        - online
        - offline
      title: UnmanagedState
    ProviderErrorMessage:
      properties:
        message:
          type: string
          title: Message
      type: object
      required:
        - message
      title: ProviderErrorMessage
    EnvVar:
      properties:
        name:
          type: string
          title: Name
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        required:
          type: boolean
          title: Required
          default: false
      additionalProperties: true
      type: object
      required:
        - name
      title: EnvVar
    ProviderType:
      type: string
      enum:
        - managed
        - unmanaged
      title: ProviderType
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    DockerImageID:
      type: string
      title: DockerImageID
    AgentInterface:
      properties:
        transport:
          type: string
          title: Transport
          examples:
            - JSONRPC
            - GRPC
            - HTTP+JSON
        url:
          type: string
          title: Url
          examples:
            - https://api.example.com/a2a/v1
            - https://grpc.example.com/a2a
            - https://rest.example.com/v1
      type: object
      required:
        - transport
        - url
      title: AgentInterface
      description: >-
        Declares a combination of a target URL and a transport protocol for
        interacting with the agent.

        This allows agents to expose the same functionality over multiple
        transport mechanisms.
    AgentCapabilities:
      properties:
        extensions:
          anyOf:
            - items:
                $ref: '#/components/schemas/AgentExtension'
              type: array
            - type: 'null'
          title: Extensions
        pushNotifications:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Pushnotifications
        stateTransitionHistory:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Statetransitionhistory
        streaming:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Streaming
      type: object
      title: AgentCapabilities
      description: Defines optional capabilities supported by an agent.
    AgentProvider:
      properties:
        organization:
          type: string
          title: Organization
        url:
          type: string
          title: Url
      type: object
      required:
        - organization
        - url
      title: AgentProvider
      description: Represents the service provider of an agent.
    SecurityScheme-Input:
      anyOf:
        - $ref: '#/components/schemas/APIKeySecurityScheme'
        - $ref: '#/components/schemas/HTTPAuthSecurityScheme'
        - $ref: '#/components/schemas/OAuth2SecurityScheme-Input'
        - $ref: '#/components/schemas/OpenIdConnectSecurityScheme'
        - $ref: '#/components/schemas/MutualTLSSecurityScheme'
      title: SecurityScheme
    AgentCardSignature:
      properties:
        header:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Header
        protected:
          type: string
          title: Protected
        signature:
          type: string
          title: Signature
      type: object
      required:
        - protected
        - signature
      title: AgentCardSignature
      description: |-
        AgentCardSignature represents a JWS signature of an AgentCard.
        This follows the JSON format of an RFC 7515 JSON Web Signature (JWS).
    AgentSkill:
      properties:
        description:
          type: string
          title: Description
        examples:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Examples
          examples:
            - - I need a recipe for bread
        id:
          type: string
          title: Id
        inputModes:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Inputmodes
        name:
          type: string
          title: Name
        outputModes:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Outputmodes
        security:
          anyOf:
            - items:
                additionalProperties:
                  items:
                    type: string
                  type: array
                type: object
              type: array
            - type: 'null'
          title: Security
          examples:
            - - google:
                  - oidc
        tags:
          items:
            type: string
          type: array
          title: Tags
          examples:
            - - cooking
              - customer support
              - billing
      type: object
      required:
        - description
        - id
        - name
        - tags
      title: AgentSkill
      description: Represents a distinct capability or function that an agent can perform.
    ResolvedDockerImageID:
      properties:
        registry:
          type: string
          title: Registry
        repository:
          type: string
          title: Repository
        tag:
          type: string
          title: Tag
        digest:
          type: string
          title: Digest
        image_id:
          $ref: '#/components/schemas/DockerImageID'
          readOnly: true
      type: object
      required:
        - registry
        - repository
        - tag
        - digest
        - image_id
      title: ResolvedDockerImageID
    ResolvedGithubUrl:
      properties:
        host:
          type: string
          title: Host
          default: github.com
        org:
          type: string
          title: Org
        repo:
          type: string
          title: Repo
        version:
          type: string
          title: Version
        version_type:
          $ref: '#/components/schemas/GithubVersionType'
        commit_hash:
          type: string
          title: Commit Hash
        path:
          anyOf:
            - type: string
            - type: 'null'
          title: Path
      type: object
      required:
        - org
        - repo
        - version
        - version_type
        - commit_hash
      title: ResolvedGithubUrl
    GithubUrl:
      type: string
      title: GithubUrl
    SecurityScheme-Output:
      anyOf:
        - $ref: '#/components/schemas/APIKeySecurityScheme'
        - $ref: '#/components/schemas/HTTPAuthSecurityScheme'
        - $ref: '#/components/schemas/OAuth2SecurityScheme-Output'
        - $ref: '#/components/schemas/OpenIdConnectSecurityScheme'
        - $ref: '#/components/schemas/MutualTLSSecurityScheme'
      title: SecurityScheme
    AgentExtension:
      properties:
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        params:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Params
        required:
          anyOf:
            - type: boolean
            - type: 'null'
          title: Required
        uri:
          type: string
          title: Uri
      type: object
      required:
        - uri
      title: AgentExtension
      description: A declaration of a protocol extension supported by an Agent.
    APIKeySecurityScheme:
      properties:
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        in:
          $ref: '#/components/schemas/In'
        name:
          type: string
          title: Name
        type:
          type: string
          const: apiKey
          title: Type
          default: apiKey
      type: object
      required:
        - in
        - name
      title: APIKeySecurityScheme
      description: Defines a security scheme using an API key.
    HTTPAuthSecurityScheme:
      properties:
        bearerFormat:
          anyOf:
            - type: string
            - type: 'null'
          title: Bearerformat
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        scheme:
          type: string
          title: Scheme
        type:
          type: string
          const: http
          title: Type
          default: http
      type: object
      required:
        - scheme
      title: HTTPAuthSecurityScheme
      description: Defines a security scheme using HTTP authentication.
    OAuth2SecurityScheme-Input:
      properties:
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        flows:
          $ref: '#/components/schemas/OAuthFlows'
        oauth2MetadataUrl:
          anyOf:
            - type: string
            - type: 'null'
          title: Oauth2Metadataurl
        type:
          type: string
          const: oauth2
          title: Type
          default: oauth2
      type: object
      required:
        - flows
      title: OAuth2SecurityScheme
      description: Defines a security scheme using OAuth 2.0.
    OpenIdConnectSecurityScheme:
      properties:
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        openIdConnectUrl:
          type: string
          title: Openidconnecturl
        type:
          type: string
          const: openIdConnect
          title: Type
          default: openIdConnect
      type: object
      required:
        - openIdConnectUrl
      title: OpenIdConnectSecurityScheme
      description: Defines a security scheme using OpenID Connect.
    MutualTLSSecurityScheme:
      properties:
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        type:
          type: string
          const: mutualTLS
          title: Type
          default: mutualTLS
      type: object
      title: MutualTLSSecurityScheme
      description: Defines a security scheme using mTLS authentication.
    GithubVersionType:
      type: string
      enum:
        - head
        - tag
      title: GithubVersionType
    OAuth2SecurityScheme-Output:
      properties:
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        flows:
          $ref: '#/components/schemas/OAuthFlows'
        oauth2MetadataUrl:
          anyOf:
            - type: string
            - type: 'null'
          title: Oauth2Metadataurl
        type:
          type: string
          const: oauth2
          title: Type
          default: oauth2
      type: object
      required:
        - flows
      title: OAuth2SecurityScheme
      description: Defines a security scheme using OAuth 2.0.
    In:
      type: string
      enum:
        - cookie
        - header
        - query
      title: In
      description: The location of the API key.
    OAuthFlows:
      properties:
        authorizationCode:
          anyOf:
            - $ref: '#/components/schemas/AuthorizationCodeOAuthFlow'
            - type: 'null'
        clientCredentials:
          anyOf:
            - $ref: '#/components/schemas/ClientCredentialsOAuthFlow'
            - type: 'null'
        implicit:
          anyOf:
            - $ref: '#/components/schemas/ImplicitOAuthFlow'
            - type: 'null'
        password:
          anyOf:
            - $ref: '#/components/schemas/PasswordOAuthFlow'
            - type: 'null'
      type: object
      title: OAuthFlows
      description: Defines the configuration for the supported OAuth 2.0 flows.
    AuthorizationCodeOAuthFlow:
      properties:
        authorizationUrl:
          type: string
          title: Authorizationurl
        refreshUrl:
          anyOf:
            - type: string
            - type: 'null'
          title: Refreshurl
        scopes:
          additionalProperties:
            type: string
          type: object
          title: Scopes
        tokenUrl:
          type: string
          title: Tokenurl
      type: object
      required:
        - authorizationUrl
        - scopes
        - tokenUrl
      title: AuthorizationCodeOAuthFlow
      description: Defines configuration details for the OAuth 2.0 Authorization Code flow.
    ClientCredentialsOAuthFlow:
      properties:
        refreshUrl:
          anyOf:
            - type: string
            - type: 'null'
          title: Refreshurl
        scopes:
          additionalProperties:
            type: string
          type: object
          title: Scopes
        tokenUrl:
          type: string
          title: Tokenurl
      type: object
      required:
        - scopes
        - tokenUrl
      title: ClientCredentialsOAuthFlow
      description: Defines configuration details for the OAuth 2.0 Client Credentials flow.
    ImplicitOAuthFlow:
      properties:
        authorizationUrl:
          type: string
          title: Authorizationurl
        refreshUrl:
          anyOf:
            - type: string
            - type: 'null'
          title: Refreshurl
        scopes:
          additionalProperties:
            type: string
          type: object
          title: Scopes
      type: object
      required:
        - authorizationUrl
        - scopes
      title: ImplicitOAuthFlow
      description: Defines configuration details for the OAuth 2.0 Implicit flow.
    PasswordOAuthFlow:
      properties:
        refreshUrl:
          anyOf:
            - type: string
            - type: 'null'
          title: Refreshurl
        scopes:
          additionalProperties:
            type: string
          type: object
          title: Scopes
        tokenUrl:
          type: string
          title: Tokenurl
      type: object
      required:
        - scopes
        - tokenUrl
      title: PasswordOAuthFlow
      description: >-
        Defines configuration details for the OAuth 2.0 Resource Owner Password
        flow.
  securitySchemes:
    HTTPBasic:
      type: http
      scheme: basic
    HTTPBearer:
      type: http
      scheme: bearer

````